"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.parseValuesWith = exports.hasBlacklistedChars = exports.getPlainTextTags = exports.stripIds = exports.parseTags = exports.tagShape = void 0;

var _reject2 = _interopRequireDefault(require("lodash/fp/reject"));

var _uniqueId2 = _interopRequireDefault(require("lodash/fp/uniqueId"));

var _split2 = _interopRequireDefault(require("lodash/fp/split"));

var _map2 = _interopRequireDefault(require("lodash/fp/map"));

var _last2 = _interopRequireDefault(require("lodash/fp/last"));

var _join2 = _interopRequireDefault(require("lodash/fp/join"));

var _isEqual2 = _interopRequireDefault(require("lodash/fp/isEqual"));

var _isEmpty2 = _interopRequireDefault(require("lodash/fp/isEmpty"));

var _intersection2 = _interopRequireDefault(require("lodash/fp/intersection"));

var _get2 = _interopRequireDefault(require("lodash/fp/get"));

var _flow2 = _interopRequireDefault(require("lodash/fp/flow"));

var _filter2 = _interopRequireDefault(require("lodash/fp/filter"));

var _curry2 = _interopRequireDefault(require("lodash/fp/curry"));

var _clipboard = _interopRequireDefault(require("clipboard"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _mousetrap = _interopRequireDefault(require("mousetrap"));

var _SimpleTag = _interopRequireDefault(require("./SimpleTag"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var KEYBOARD_SHORTCUTS = ['enter', 'esc', 'backspace', 'mod+a', 'mod+v'];

var tagShape = _propTypes["default"].shape({
  value: _propTypes["default"].string.isRequired,
  // Special marks the tag as different. For example a special tag when using
  // the case-sensitive options is a case-sensitive tag
  special: _propTypes["default"].bool
});

exports.tagShape = tagShape;
var propTypes = {
  // Characters not allowed in the tags, defaults to `[',']` and must always
  // contain `,`
  blacklistChars: _propTypes["default"].arrayOf(_propTypes["default"].string),
  // Renders a copy to clipboard button
  copyButton: _propTypes["default"].bool,
  // Label for the copy to clipboard button
  copyButtonLabel: _propTypes["default"].string,
  // Error message rendered below the field. When the field is set it will
  // also has the class `is-error`
  error: _propTypes["default"].string,
  // Rendered above the field itself
  label: _propTypes["default"].string,
  placeholder: _propTypes["default"].string,
  // Array of tags to display
  tags: _propTypes["default"].arrayOf(tagShape),
  // Returns a custom way to render the tag
  tagRenderer: _propTypes["default"].func,
  // Enable the creation of special tags
  specialTags: _propTypes["default"].bool,
  // Returns a custom way to render the special button
  specialButtonRenderer: _propTypes["default"].func,
  // Label for the special button.
  // Only used when a `specialButtonRenderer` is not defined.
  specialButtonLabel: _propTypes["default"].string,
  // Fired when changing the tags with the `tags` array as the argument
  onChange: _propTypes["default"].func.isRequired,
  // Same as the standard React SyntheticEvent
  onBlur: _propTypes["default"].func,
  onFocus: _propTypes["default"].func,
  // Fired when the user interaction is considered complete, invoked with `tags`
  onSubmit: _propTypes["default"].func
};

var tagRenderer = function tagRenderer(_ref, onClick) {
  var value = _ref.value,
      special = _ref.special;
  return _react["default"].createElement(_SimpleTag["default"], {
    onClick: onClick,
    value: value,
    special: special
  });
};

var defaultProps = {
  blacklistChars: [','],
  copyButton: false,
  copyButtonLabel: 'Copy to clipboard',
  specialButtonLabel: 'Special',
  specialTags: false,
  tags: [],
  tagRenderer: tagRenderer,
  onBlur: function onBlur() {},
  onChange: function onChange() {},
  onFocus: function onFocus() {},
  onSubmit: function onSubmit() {}
};
var parseTags = (0, _map2["default"])(function (t) {
  return _objectSpread({}, t, {
    __id: (0, _uniqueId2["default"])('tag')
  });
});
exports.parseTags = parseTags;
var stripIds = (0, _map2["default"])(function (t) {
  return _objectSpread({}, t, {
    __id: undefined
  });
});
exports.stripIds = stripIds;
var getPlainTextTags = (0, _flow2["default"])((0, _map2["default"])((0, _get2["default"])('value')), (0, _join2["default"])(','));
exports.getPlainTextTags = getPlainTextTags;
var hasBlacklistedChars = (0, _curry2["default"])(function (blacklist, str) {
  return (0, _flow2["default"])((0, _split2["default"])(''), (0, _intersection2["default"])(blacklist), function (i) {
    return !(0, _isEmpty2["default"])(i);
  })(str);
});
exports.hasBlacklistedChars = hasBlacklistedChars;
var parseValuesWith = (0, _curry2["default"])(function (blacklist, str) {
  return (0, _flow2["default"])((0, _split2["default"])(','), (0, _map2["default"])(function (value) {
    if (hasBlacklistedChars(blacklist, value)) return false;
    return {
      value: value
    };
  }), (0, _reject2["default"])(_isEmpty2["default"]))(str);
});
exports.parseValuesWith = parseValuesWith;

var TagsInput =
/*#__PURE__*/
function (_React$Component) {
  _inherits(TagsInput, _React$Component);

  function TagsInput(props) {
    var _this;

    _classCallCheck(this, TagsInput);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(TagsInput).call(this, props));
    _this.state = {
      tags: parseTags(props.tags),
      // Value is what the user is typing in the input
      value: '',
      // When in focus
      isFocused: false,
      // When in selection mode renders a texarea containing comma-separated
      // list of tag values
      isSelectMode: false,
      // Paste mode is used for handling when the user pastes content
      isPasteMode: false,
      // When true the created tags will be marked as special
      isSpecial: false,
      // ID internally assigned to the input. You don't want to change this
      id: (0, _uniqueId2["default"])('TagsInput_')
    }; // Input events

    _this.handleBlurInput = _this.handleBlurInput.bind(_assertThisInitialized(_this));
    _this.handleFocusInput = _this.handleFocusInput.bind(_assertThisInitialized(_this));
    _this.handleChangeInput = _this.handleChangeInput.bind(_assertThisInitialized(_this));
    _this.handleClickFauxInput = _this.handleClickFauxInput.bind(_assertThisInitialized(_this));
    _this.handleShortcut = _this.handleShortcut.bind(_assertThisInitialized(_this)); // Textarea for copy/paste

    _this.handleBlurTextarea = _this.handleBlurTextarea.bind(_assertThisInitialized(_this));
    _this.handleFocusTextarea = _this.handleFocusTextarea.bind(_assertThisInitialized(_this)); // Other events

    _this.handleClickTagButton = _this.handleClickTagButton.bind(_assertThisInitialized(_this));
    _this.handleClickSpecial = _this.handleClickSpecial.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(TagsInput, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (!(0, _isEqual2["default"])(this.props.tags, nextProps.tags)) {
        this.setState({
          tags: parseTags(nextProps.tags),
          value: '',
          isPasteMode: false
        });
      }
    }
  }, {
    key: "componentWillUpdate",
    value: function componentWillUpdate(nextProps, nextState) {
      // When the state is in pasteMode and we have a value, parse the value
      // and reset it
      if (nextState.isPasteMode && nextState.value) {
        var parseValue = parseValuesWith(this.props.blacklistChars);
        var tags = [].concat(_toConsumableArray(nextProps.tags), _toConsumableArray(parseValue(nextState.value))); // We can't change the state here, rely on the onChange event to reset
        // the state.
        //
        // It works a folows:
        //   1. onChange is fired with new tags
        //   2. The element using this component will pass down the new tags
        //   3. In the componentWillReceiveProps lyfecycle the value is reset

        nextProps.onChange(tags);
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      // When going from select mode to normal, focus again on the input.
      // This must live in the didUpdate lyfecycle because the filed needs to be
      // already renderered with the correct params.
      if (prevState.isSelectMode && !this.state.isSelectMode) {
        this.input.focus();
      }
    }
  }, {
    key: "handleFocusInput",
    value: function handleFocusInput() {
      // Ignore the event in selectMode
      if (this.state.isSelectMode) return;
      this.setState({
        isFocused: true
      });
      this.props.onFocus();
      this.attachListeners();
    }
  }, {
    key: "handleBlurInput",
    value: function handleBlurInput() {
      // Ignore the blur event in selectMode
      if (this.state.isSelectMode) return;
      this.setState({
        isFocused: false
      });
      this.props.onBlur();
      this.removeListeners();
    }
  }, {
    key: "handleChangeInput",
    value: function handleChangeInput(event) {
      var value = event.target.value;
      var lastChar = (0, _last2["default"])(value); // If the value ends with a comma and it's not just a comma create a new
      // tag.
      // The order is imorant, this conditions goes before the blacklisting

      if (value.length > 1 && lastChar === ',') {
        return this.createTag();
      } // Ignore leading white spaces


      if (value.length === 1 && value === ' ') return null;
      if (this.props.blacklistChars.includes(lastChar)) return null;
      return this.setState({
        value: value
      });
    }
  }, {
    key: "handleClickFauxInput",
    value: function handleClickFauxInput(event) {
      if (this.state.isFocused) {
        event.preventDefault();
        event.stopPropagation();
        return;
      }

      this.input.focus();
    }
  }, {
    key: "handleFocusTextarea",
    value: function handleFocusTextarea() {
      var _this2 = this;

      _mousetrap["default"].bind('mod+c', function () {
        return _this2.handleShortcut('mod+c');
      });
    }
  }, {
    key: "handleBlurTextarea",
    value: function handleBlurTextarea() {
      this.setState({
        isSelectMode: false
      });

      _mousetrap["default"].unbind('mod+c');
    }
    /**
     * Fire a change event without the passed tag
     */

  }, {
    key: "handleClickTagButton",
    value: function handleClickTagButton(id) {
      var tags = (0, _flow2["default"])((0, _filter2["default"])(function (t) {
        return t.__id !== id;
      }), stripIds)(this.state.tags);
      this.props.onChange(tags);
    }
    /**
     * Toggle the special state
     */

  }, {
    key: "handleClickSpecial",
    value: function handleClickSpecial() {
      this.setState(function (state) {
        return {
          isSpecial: !state.isSpecial
        };
      });
    }
  }, {
    key: "handleShortcut",
    value: function handleShortcut(type) {
      var _this3 = this;

      switch (type) {
        // Create a new tag
        case 'enter':
          {
            // Whe the user press enter and there is no text currently being
            // wrtitten, fire the onSubmit event
            if (!this.state.value.length) return this.submitTags();
            return this.createTag();
          }

        case 'esc':
          {
            // Reset the input value when pressing esc if we have a value
            if (this.state.value) return this.setState({
              value: ''
            });
            return this.input.blur();
          }
        // When the value of the input is empty and the user presses backspace,
        // delete the previous tag

        case 'backspace':
          {
            if (this.state.value.length || !this.props.tags.length) return null; // Remove the last tag in the array (in an immutable way)

            var tags = _toConsumableArray(this.props.tags);

            tags.pop();
            return this.props.onChange(tags);
          }
        // Select the content of the plaintext field

        case 'mod+a':
          {
            // Ignore the event if the user is typing
            if (this.state.value.length) return null;
            return this.setState({
              isSelectMode: true
            });
          }
        // The user copied to the clipboard, so reset the selcted state

        case 'mod+c':
          return window.setTimeout(function () {
            return _this3.setState({
              isSelectMode: false
            });
          }, 100);
        // When pasting, we'll receive the data in the next state update

        case 'mod+v':
          return this.setState({
            isPasteMode: true
          });

        default:
          return null;
      }
    }
    /**
     * Listen for keys and key combinations
     */

  }, {
    key: "attachListeners",
    value: function attachListeners() {
      var _this4 = this;

      KEYBOARD_SHORTCUTS.forEach(function (key) {
        return _mousetrap["default"].bind(key, function () {
          return _this4.handleShortcut(key);
        });
      });
    }
    /**
     * Remove all the document listeners
     */

  }, {
    key: "removeListeners",
    value: function removeListeners() {
      KEYBOARD_SHORTCUTS.forEach(function (key) {
        return _mousetrap["default"].unbind(key);
      });
    }
    /**
     * Create a tag from the current state value
     */

  }, {
    key: "createTag",
    value: function createTag() {
      var tags = [].concat(_toConsumableArray(this.state.tags), [{
        value: this.state.value,
        special: this.state.isSpecial
      }]);
      this.props.onChange(tags);
    }
  }, {
    key: "submitTags",
    value: function submitTags() {
      var tags = stripIds(this.state.tags);
      this.props.onSubmit(tags);
    }
  }, {
    key: "textareaRef",
    value: function textareaRef(el) {
      if (!el) return; // Focus on the textarea

      el.focus();
    }
  }, {
    key: "copyButtonRef",
    value: function copyButtonRef(el) {
      var _this5 = this;

      if (!el) return;
      if (this.clipboard) this.clipboard.destroy();
      this.clipboard = new _clipboard["default"](el, {
        text: function text() {
          return getPlainTextTags(_this5.state.tags);
        }
      });
    }
    /**
     * The header block contains:
     *  - Label
     *  - Special button with tooltip
     */

  }, {
    key: "renderHeaderBlock",
    value: function renderHeaderBlock() {
      var _this$props = this.props,
          label = _this$props.label,
          specialTags = _this$props.specialTags,
          specialButtonLabel = _this$props.specialButtonLabel,
          error = _this$props.error,
          specialButtonRenderer = _this$props.specialButtonRenderer; // When neither label or special icon is specified, render nothing

      if (!label && !specialTags) return null;
      var labelBlock;
      var buttonBlock;

      if (label) {
        var labelClassName = (0, _classnames["default"])('TagsInput__label', {
          'is-error': error
        });
        labelBlock = _react["default"].createElement("label", {
          className: labelClassName,
          htmlFor: this.state.id
        }, label);
      }

      if (specialTags && specialButtonRenderer) {
        buttonBlock = specialButtonRenderer(this.state.isSpecial, this.handleClickSpecial);
      } else if (specialTags && specialButtonLabel) {
        var btnClassName = (0, _classnames["default"])('TagsInput__special-btn', {
          'is-active': this.state.isSpecial
        });
        buttonBlock = _react["default"].createElement("button", {
          className: btnClassName,
          onClick: this.handleClickSpecial
        }, specialButtonLabel);
      }

      return _react["default"].createElement("div", {
        className: "TagsInput__header"
      }, labelBlock, buttonBlock);
    }
    /**
     * The footer block contains:
     *  - Copy button
     *  - Erorr message
     */

  }, {
    key: "renderFooterBlock",
    value: function renderFooterBlock() {
      var _this6 = this;

      var _this$props2 = this.props,
          copyButton = _this$props2.copyButton,
          copyButtonLabel = _this$props2.copyButtonLabel,
          error = _this$props2.error; // Render nothing when neHither an error nor the button in required

      if (!copyButton && !error) return null;
      var buttonBlock;
      var errorBlock;

      if (copyButton) {
        buttonBlock = _react["default"].createElement("button", {
          className: "TagsInput__copy-btn",
          ref: function ref(el) {
            return _this6.copyButtonRef(el);
          }
        }, copyButtonLabel);
      }

      if (error) {
        errorBlock = _react["default"].createElement("span", {
          className: "TagsInput__error"
        }, error);
      }

      return _react["default"].createElement("div", {
        className: "TagsInput__footer"
      }, errorBlock, buttonBlock);
    }
  }, {
    key: "renderActiveTags",
    value: function renderActiveTags() {
      var _this7 = this;

      var tagRenderer = this.props.tagRenderer;
      return this.state.tags.map(function (tag) {
        return _react["default"].createElement("div", {
          className: "TagsInput__tag",
          key: tag.__id
        }, tagRenderer(tag, function () {
          return _this7.handleClickTagButton(tag.__id);
        }));
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this8 = this;

      var _this$props3 = this.props,
          error = _this$props3.error,
          placeholder = _this$props3.placeholder;
      var headerBlock = this.renderHeaderBlock();
      var footerBlock = this.renderFooterBlock();

      var inputRef = function inputRef(el) {
        _this8.input = el;
      };

      var inputWidth = "".concat(this.state.value.length + 1, "ch");
      var inputClassName = (0, _classnames["default"])('TagsInput__input', {
        'is-focused': this.state.isFocused || this.state.isSelectMode,
        'is-selected': this.state.isSelectMode,
        'is-error': error
      });
      var activeTags; // In selectMode render a texarea whith the content already pre-selected.
      // Why a texarea? Beacause it can wrap to the next line, an input can't

      if (this.state.isSelectMode) {
        activeTags = _react["default"].createElement("textarea", {
          className: "TagsInput__textarea mousetrap",
          value: getPlainTextTags(this.state.tags),
          ref: function ref(el) {
            return _this8.textareaRef(el);
          },
          onFocus: this.handleFocusTextarea,
          onBlur: this.handleBlurTextarea,
          readOnly: true
        });
      } else {
        activeTags = this.renderActiveTags();
      }

      var placeholderBlock;

      if (placeholder && !this.state.value && !this.state.tags.length) {
        placeholderBlock = _react["default"].createElement("span", {
          className: "TagsInput__placeholder"
        }, placeholder);
      }

      return _react["default"].createElement("div", {
        className: "TagsInput"
      }, headerBlock, _react["default"].createElement("div", {
        className: "TagsInput__field"
      }, _react["default"].createElement("div", {
        className: inputClassName,
        onClick: this.handleClickFauxInput
      }, activeTags, placeholderBlock, _react["default"].createElement("input", {
        type: "text",
        id: this.state.id,
        style: {
          width: inputWidth
        },
        className: "TagsInput__text mousetrap",
        value: this.state.value,
        ref: inputRef,
        onChange: this.handleChangeInput,
        onBlur: this.handleBlurInput,
        onFocus: this.handleFocusInput
      }))), footerBlock);
    }
  }]);

  return TagsInput;
}(_react["default"].Component);

TagsInput.propTypes = propTypes;
TagsInput.defaultProps = defaultProps;
var _default = TagsInput;
exports["default"] = _default;